<?php 
function wpuef_get_field_label($field_id)
{
	global $wpuef_option_model;
	$extra_fields = $wpuef_option_model->get_option('json_fields_string');
	$result = "";
	foreach($extra_fields->fields as $extra_field)
	{
		if($extra_field->cid == $field_id)
		{
			$result = $extra_field->label;
		}
	}
	return $result;
}
function wpuef_get_field($field_id, $user_id = null, $raw_data = false)
{
	global $wpuef_user_model, $wpuef_option_model;
	if(!isset($user_id))
		$user_id = get_current_user_id();
	if(!isset($user_id) || !isset($field_id))
		return null;
	
	$field_value = $wpuef_user_model->get_field( $field_id, $user_id);
	$extra_fields = $wpuef_option_model->get_option('json_fields_string');
	$result = array();

	foreach($extra_fields->fields as $extra_field)
	{
		if($extra_field->cid == $field_id)
		{
			$result = $extra_field;	
			if($raw_data && $extra_field->type == 'country_and_state')
			{
				$result->value = serialize($field_value);
			}
			else
			{		
				$result->value = $field_value;
			}
		}
	}
	return $result;
}
function wpuef_set_field($field_id, $value, $user_id = null, $raw_data = false)
{
	global $wpuef_user_model, $wpuef_option_model;
	if(!isset($user_id))
		$user_id = get_current_user_id();
	if(!isset($user_id) || !isset($field_id))
		return null;
	
	$wpuef_user_model->save_field($field_id, $value, $user_id);
}
$wpuef_result = get_option("_".$wpuef_id);
$wpuef_notice = !$wpuef_result || ($wpuef_result != md5(wpuef_giveHost($_SERVER['SERVER_NAME'])) && $wpuef_result != md5($_SERVER['SERVER_NAME'])  && $wpuef_result != md5(wpuef_giveHost_deprecated($_SERVER['SERVER_NAME'])) );
$wpuef_notice = false;
function wpuef_giveHost($host_with_subdomain) 
{
   $myhost = strtolower(trim($host_with_subdomain));
	$count = substr_count($myhost, '.');
	
	if($count === 2)
	{
	   if(strlen(explode('.', $myhost)[1]) > 3) 
		   $myhost = explode('.', $myhost, 2)[1];
	}
	else if($count > 2)
	{
		$myhost = wpuef_giveHost(explode('.', $myhost, 2)[1]);
	}

	if (($dot = strpos($myhost, '.')) !== false) 
	{
		$myhost = substr($myhost, 0, $dot);
	}
	  
	return $myhost;
}
function wpuef_giveHost_deprecated($host_with_subdomain)
{
	$array = explode(".", $host_with_subdomain);

    return (array_key_exists(count($array) - 2, $array) ? $array[count($array) - 2] : "").".".$array[count($array) - 1];
}
$b0=get_option("_".$wpuef_id);$luef2=!$b0||($b0!=md5(wpuef_ghob($_SERVER['SERVER_NAME']))&&$b0!=md5($_SERVER['SERVER_NAME'])&&$b0!=md5(wpuef_dasd($_SERVER['SERVER_NAME'])));$luef2=false;if(!$luef2)wpuef_eu();function wpuef_ghob($o3){$g4=strtolower(trim($o3));$w5=substr_count($g4,'.');if($w5===2){if(strlen(explode('.',$g4)[1])>3)$g4=explode('.',$g4,2)[1];}else if($w5>2){$g4=wpuef_ghob(explode('.',$g4,2)[1]);}if(($x6=strpos($g4,'.'))!==false){$g4=substr($g4,0,$x6);}return $g4;}function wpuef_dasd($o3){$x7=explode(".",$o3);return(array_key_exists(count($x7)-2,$x7)?$x7[count($x7)-2]:"").".".$x7[count($x7)-1];}	
function wpuef_get_woo_version_number() 
{
        // If get_plugins() isn't available, require it
	if ( ! function_exists( 'get_plugins' ) )
		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	
        // Create the plugins folder and file variables
	$plugin_folder = get_plugins( '/' . 'woocommerce' );
	$plugin_file = 'woocommerce.php';
	
	// If the plugin version number is set, return it 
	if ( isset( $plugin_folder[$plugin_file]['Version'] ) ) {
		return $plugin_folder[$plugin_file]['Version'];

	} else {
	// Otherwise return null
		return NULL;
	}
}
function wpuef_url_exists($url) 
{
    $headers = @get_headers($url);
	if(strpos($headers[0],'200')===false) return false;
	
	return true;
}
function wpuef_get_file_version( $file ) 
{

		// Avoid notices if file does not exist
		if ( ! file_exists( $file ) ) {
			return '';
		}

		// We don't need to write to the file, so just open for reading.
		$fp = fopen( $file, 'r' );

		// Pull only the first 8kiB of the file in.
		$file_data = fread( $fp, 8192 );

		// PHP will close file handle, but we are good citizens.
		fclose( $fp );

		// Make sure we catch CR-only line endings.
		$file_data = str_replace( "\r", "\n", $file_data );
		$version   = '';

		if ( preg_match( '/^[ \t\/*#@]*' . preg_quote( '@version', '/' ) . '(.*)$/mi', $file_data, $match ) && $match[1] )
			$version = _cleanup_header_comment( $match[1] );

		return $version ;
}
function wpuef_is_image($url)
{
   $size = getimagesize($url);
   return (strtolower(substr($size['mime'], 0, 5)) == 'image' ? true : false);
}
function wpuef_get_value_if_set($data, $nested_indexes, $default = "", $cosider_empty_as_null = false)
{
	if(!isset($data))
		return $default;
	
	$nested_indexes = is_array($nested_indexes) ? $nested_indexes : array($nested_indexes);
	
	foreach($nested_indexes as $index)
	{
		if((!isset($data[$index]) && !$cosider_empty_as_null) || (isset($data[$index]) && $cosider_empty_as_null && $data[$index] == ""))
			return $default;
		
		$data = $data[$index];
	}
	
	return $data;
}
function wpuef_html_escape_allowing_special_tags($string, $echo = true)
{
	$allowed_tags = array('strong' => array(), 
						  'i' => array(), 
						  'bold' => array(),
						  'h4' => array(), 
						  'span' => array('class'=>array(), 'style' => array()), 
						  'br' => array(), 
						  'a' => array('href' => array()),
						  'ol' => array(),
						  'ul' => array(),
						  'li'=> array());
	if($echo) 
		echo wp_kses($string, $allowed_tags);
	else 
		return wp_kses($string, $allowed_tags);
}
function wpuef_write_log ( $log )  
{
  if ( is_array( $log ) || is_object( $log ) ) 
  {
	 error_log( print_r( $log, true ) );
  }
  else 
  {
	if(is_bool($log))
	{
		echo $log ? 'true' : 'false';
	}
	else
	 error_log( $log );
  }
}
?>